=== streams/icons/CMakeLists.txt ===
file(GLOB svg_files *.svg)
file(GLOB png_files *.png)
if (WIN32)
    install(FILES ${svg_files} ${png_files} DESTINATION ${CMAKE_INSTALL_PREFIX}/streamicons/)
else (WIN32)
    install(FILES ${svg_files} ${png_files} DESTINATION ${CMAKE_INSTALL_PREFIX}/share/${CMAKE_PROJECT_NAME}/streamicons/)
endif (WIN32)
