=== debian/changelog ===
cantata (1.0.3-0ubuntu3) saucy; urgency=low

  * Built with support for playing back MPD HTTP streams via Phonon
  * New build-depends libmp3lame-dev
  * New build-depends libtag-extras-dev, libspeexdsp-dev
  * New build-depends libudev-dev, libavcodec-dev, libavformat-dev

 -- Ben Vassie <vassie@ntlworld.com>  Tue, 02 June 2013 19:09:37 +0100

cantata (1.0.3-0ubuntu2) raring; urgency=low

  * New upstream release

 -- Ben Vassie <vassie@ntlworld.com>  Tue, 28 May 2013 14:05:41 +0100

cantata (1.0.2-0ubuntu2) raring; urgency=low

  * New upstream release
  * New build-depends libcdparanoia-dev, libmusicbrainz5-dev, libcddb2-dev

 -- Ben Vassie <vassie@ntlworld.com>  Tue, 21 May 2013 20:53:39 +0100
