=== debian/control ===
Source: cantata
Section: kde
Priority: extra
Maintainer: Kubuntu Developers <kubuntu-devel@lists.ubuntu.com>
XSBC-Original-Maintainer: Ben Vassie <vassie@ntlworld.com>
Build-Depends: debhelper (>= 8.0.0), cmake, libx11-dev, libqt4-dev, kdelibs5-dev, libtag1-dev, libcdparanoia-dev, libcddb2-dev, libmusicbrainz5-dev, libmtp-dev, libmpg123-dev, libmp3lame-dev, libphonon-dev, libtag-extras-dev, libspeexdsp-dev, libudev-dev, libavcodec-dev, libavformat-dev
Standards-Version: 3.9.4
Homepage: https://code.google.com/p/cantata

Package: cantata
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: client for music player daemon (MPD)
 Cantata is a Qt4/KDE4 client for the music player daemon
 (MPD). Originally started as a fork of QtMPC, the code is now very
 different. Cantata can be compiled with KDE support, or as a pure Qt4
 application. The interface is very configurable - most views can be
 shown as either a list or tree structure.
