=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

override_dh_auto_configure:
	dh_auto_configure -- -DENABLE_PHONON=ON

%:
	dh $@
