=== debian/changelog ===
cantata (1.1.0-0ubuntu1) saucy; urgency=low

  * New upstream release

 -- Ben Vassie <vassie@ntlworld.com>  Thu, 15 Aug 2013 09:18:44 +0100

cantata (1.0.3-0ubuntu14) raring; urgency=low

  * Added debian/watch

 -- Ben Vassie <vassie@ntlworld.com>  Mon, 17 Jun 2013 15:21:18 +0100

cantata (1.0.3-0ubuntu13) raring; urgency=low

  * Cleaned up build-depeneds and rules

 -- Ben Vassie <vassie@ntlworld.com>  Wed, 12 Jun 2013 18:54:39 +0100

cantata (1.0.3-0ubuntu11) raring; urgency=low

  * Added build-depends libqt4-core, libqt4-gui libqt4-network
  * Added build-depends libqt4-xml, libqt4-dbus, kdelibs5-dev

 -- Ben Vassie <vassie@ntlworld.com>  Mon, 10 Jun 2013 09:06:01 +0100

cantata (1.0.3-0ubuntu10) raring; urgency=low

  * Fixed DCMAKE_INSTALL_PREFIX path

 -- Ben Vassie <vassie@ntlworld.com>  Sun, 09 Jun 2013 10:51:46 +0100

cantata (1.0.3-0ubuntu9) raring; urgency=low

  * New build-depends libtag-extras-dev, libspeexdsp-dev
  * New build-depends libudev-dev, libavcodec-dev, libavformat-dev

 -- Ben Vassie <vassie@ntlworld.com>  Wed, 05 Jun 2013 09:57:43 +0100

cantata (1.0.3-0ubuntu8) raring; urgency=low

  * Icon fixed that was missing during the PPA build

 -- Ben Vassie <vassie@ntlworld.com>  Wed, 05 Jun 2013 09:36:54 +0100

cantata (1.0.3-0ubuntu7) raring; urgency=low

  * Fixed missing icon

 -- Ben Vassie <vassie@ntlworld.com>  Tue, 04 Jun 2013 22:09:16 +0100

cantata (1.0.3-0ubuntu6) raring; urgency=low

  * Removed unused build-depends

 -- Ben Vassie <vassie@ntlworld.com>  Tue, 04 Jun 2013 10:48:02 +0100

cantata (1.0.3-0ubuntu5) raring; urgency=low

  * New build-depends libmp3lame-dev

 -- Ben Vassie <vassie@ntlworld.com>  Mon, 03 Jun 2013 19:07:17 +0100

cantata (1.0.3-0ubuntu3) raring; urgency=low

  * Built with support for playing back MPD HTTP streams via Phonon

 -- Ben Vassie <vassie@ntlworld.com>  Tue, 02 June 2013 19:09:37 +0100
