=== debian/changelog ===
cantata (1.1.2-0ubuntu1) saucy; urgency=low

  * New upstream release

 -- Ben Vassie <vassie@ntlworld.com>  Thu, 05 Sep 2013 07:34:25 +0100

cantata (1.1.0-0ubuntu1~ubuntu13.04) raring; urgency=low

  * New upstream release

 -- Ben Vassie <vassie@ntlworld.com>  Thu, 15 Aug 2013 09:18:44 +0100
