=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: extra
 Maintainer: Kubuntu Developers <kubuntu-devel@lists.ubuntu.com>
 XSBC-Original-Maintainer: Ben Vassie <vassie@ntlworld.com>
-Build-Depends: debhelper (>= 8.0.0), cmake, libx11-dev, libqt4-dev, kdelibs5-dev, libtag1-dev, libcdparanoia-dev, libcddb2-dev, libmusicbrainz5-dev, libmtp-dev, libmpg123-dev, libmp3lame-dev, libphonon-dev, libtag-extras-dev, libspeexdsp-dev, libudev-dev, libavcodec-dev, libavformat-dev
+Build-Depends: debhelper (>= 8.0.0), cmake, libx11-dev, libqt4-dev, kdelibs5-dev, libtag1-dev, libcdparanoia-dev, libcddb2-dev, libmusicbrainz5-dev, libmtp-dev, libmpg123-dev, libmp3lame-dev, libphonon-dev, libtag-extras-dev, libspeexdsp-dev, libudev-dev, libavcodec-dev, libavformat-dev, libqjson-dev
 Standards-Version: 3.9.4
 Homepage: https://code.google.com/p/cantata
